This service will be undergoing maintenance at 00:00 UTC, 2017-10-23 It is expected to last about 30 minutes
Bug 1468487 - (CVE-2017-10978) CVE-2017-10978 freeradius: Out-of-bounds read/write due to improper output buffer size check in make_secret()
CVE-2017-10978 freeradius: Out-of-bounds read/write due to improper output bu...
Status: CLOSED ERRATA
Product: Security Response
Classification: Other
Component: vulnerability (Show other bugs)
unspecified
All Linux
medium Severity medium
: ---
: ---
Assigned To: Red Hat Product Security
impact=moderate,public=20170717,repor...
: Security
Depends On: 1469117 1469408 1471848 1469118 1469409
Blocks: 1468570
  Show dependency treegraph
 
Reported: 2017-07-07 04:51 EDT by Adam Mariš
Modified: 2017-08-02 05:45 EDT (History)
6 users (show)

See Also:
Fixed In Version: freeradius 2.2.10, freeradius 3.0.15
Doc Type: If docs needed, set a value
Doc Text:
An out-of-bounds read and write flaw was found in the way FreeRADIUS server handled RADIUS packets. A remote attacker could use this flaw to crash the FreeRADIUS server by sending a specially crafted RADIUS packet.
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-08-02 05:35:39 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Proposed patch (2.00 KB, patch)
2017-07-07 08:16 EDT, Adam Mariš
no flags Details | Diff
Proposed patch for v3 (1.91 KB, patch)
2017-07-11 08:01 EDT, Nikolai Kondrashov
no flags Details | Diff

  None (edit)
Description Adam Mariš 2017-07-07 04:51:27 EDT
The make_secret() function does not properly check for output buffer size before writing data. It can perform a read or write overflow of up to 16 octets.

The issue can happen when when the server is sending a RADIUS packet that is almost at the maximum (4K octets), and the last attribute in the packet is an Ascend-Send-Secret (or similar) attribute. The data being written is an MD5 digest of the shared secret, concatenated to data which is under the attackers control.

This issue can also happen when receiving a packet that has an Ascend-Send-Secret (or similar) attribute of the wrong size. The server will read data past the end of the attribute, up to a limit of 16 octets.

The security impact is denial of service by anyone who can send packets which are accepted by the server.

Affected versions: 2.0.0 through 3.0.14, inclusive.
Comment 1 Adam Mariš 2017-07-07 04:51:35 EDT
Acknowledgments:

Name: the FreeRADIUS project
Upstream: Guido Vranken
Comment 2 Adam Mariš 2017-07-07 08:16 EDT
Created attachment 1295282 [details]
Proposed patch
Comment 7 Nikolai Kondrashov 2017-07-11 08:01 EDT
Created attachment 1296197 [details]
Proposed patch for v3
Comment 8 Dhiru Kholia 2017-07-17 10:30:01 EDT
Created freeradius tracking bugs for this issue:

Affects: fedora-all [bug 1471848]
Comment 9 errata-xmlrpc 2017-07-17 23:41:54 EDT
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 6

Via RHSA-2017:1759 https://access.redhat.com/errata/RHSA-2017:1759
Comment 10 errata-xmlrpc 2017-08-01 19:24:54 EDT
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7

Via RHSA-2017:2389 https://access.redhat.com/errata/RHSA-2017:2389
Comment 11 Dhiru Kholia 2017-08-02 05:45:29 EDT
External References:

http://freeradius.org/security/fuzzer-2017.html

Note You need to log in before you can comment on or make changes to this bug.